using EInk.Lot2Lot3;
using EInk.TaskThread;
using SqlSugar;
using System.Text;

Encoding.RegisterProvider(CodePagesEncodingProvider.Instance);
var builder = WebApplication.CreateBuilder(args);
// Add services to the container.
builder.Services.AddControllers();
// Learn more about configuring Swagger/OpenAPI at https://aka.ms/aspnetcore/swashbuckle
builder.Services.AddEndpointsApiExplorer();
builder.Services.AddSwaggerGen();
builder.Services.AddSingleton<IStartupFilter, TaskFilter>();
builder.Services.AddSingleton<ISqlSugarClient>(s =>
{
    SqlSugarScope sqlSugar = new(new ConnectionConfig()
    {
        DbType = DbType.PostgreSQL,
        ConnectionString = new ConfigurationBuilder().SetBasePath(Directory.GetCurrentDirectory()).AddJsonFile("appsettings.json", optional: true, reloadOnChange: true).Build().GetValue<string>("LocalDbConnectionString"),
        IsAutoCloseConnection = true,
    },
    db =>
    {
        //db.DbMaintenance.CreateDatabase();
        //db.CodeFirst.InitTables(typeof(BoxDetai2l));
        //db.Aop.OnLogExecuting = (sql, pars) =>
        //{

        //};
    });
    return sqlSugar;
});

var app = builder.Build();
app.UseSwagger();
app.UseSwaggerUI();
//app.UseHttpsRedirection();
app.UseAuthorization();
app.MapControllers();
app.Run();
