﻿using EInk.Dtos;
using EInk.Models;
using EInk.Tools;
using Newtonsoft.Json;
using SqlSugar;

namespace EInk.TaskThread
{
    public class DeleteDBRecordThread
    {
        private readonly ISqlSugarClient _db;
        public static int daysago;

        public DeleteDBRecordThread(ISqlSugarClient db, int daysago)
        {
            _db = db;
            DeleteDBRecordThread.daysago = daysago;
        }

        public void DeleteThreadStart()
        {
            Thread t = new Thread(DeleteTask);
            t.Start(_db);
        }

        static void DeleteTask(object db)
        {
            ISqlSugarClient _db = (ISqlSugarClient)db;
            while (true)
            {
                try
                {
                    int days = DeleteDBRecordThread.daysago;
                    DateTime now = DateTime.Now;
                    if (now.Hour==8 && now.Minute==0)
                    {
                        LogerHelper.RecordLogTxt($"DeleteTask, DeleteLot2Lot3Data Before {now.AddDays(-DeleteDBRecordThread.daysago).ToString()}, {_db.Deleteable<Lot2Lot3Model>().Where(x => x.create_time < now.AddDays(-DeleteDBRecordThread.daysago)).ExecuteCommand()}");
                        LogerHelper.RecordLogTxt($"DeleteTask, DeleteColourCastData Before {now.AddDays(-DeleteDBRecordThread.daysago).ToString()},  {_db.Deleteable<ColourCastModel>().Where(x => x.create_time < now.AddDays(-DeleteDBRecordThread.daysago)).ExecuteCommand()}");
                    }

                }
                catch (Exception ex)
                {
                    LogerHelper.RecordLogTxt("DeleteTask," + ex.Message);
                }
                finally
                {
                    Thread.Sleep(1000 * 60);
                }
            }

        }
    }
}
